Imports IDAutomation.Windows.Forms.DataBar_Barcode

Public Class DataBarSpecific
    Inherits CommonImpementation
    Private Const PDF417_BINARY_EXPLANATION = "You may encode up to 150 characters in Binary compaction in a MicroPDF417 barcode and " & _
        "800 characters in a PDF417 barcode.  Binary compaction allows for the encoding of all ASCII characters from 0 - 255."

    Private Const PDF417_TEXT_EXPLANATION = "You may encode up to 250 characters in Text compaction in a MicroPDF417 barcode and " & _
        "800 characters in a PDF417 barcode.  Text compaction allows for the encoding of ASCII characters from 32 - 126 as well as " & _
        "the tab, line feed, and carriage return characters."

    Private Const PDF417_NUMERIC_EXPLANATION = "You may encode up to 366 numbers in Numeric compaction in a MicroPDF417 barcode and " & _
            "800 numbers in a PDF417 barcode.  Numeric compaction allows for the encoding of only numbers.  All other characters " & _
            "will be stripped from the data to encode."
    Private Sub cboSymbology_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSymbology.SelectedIndexChanged
        If OnStartUp = False Then
            'take out elses
            If cboSymbology.Text = "CODE 128" Then
                Barcode.SymbologyID = Barcode.Symbologies.Code128

            ElseIf cboSymbology.Text = "EAN 13" Then
                Barcode.SymbologyID = Barcode.Symbologies.Ean13
            ElseIf cboSymbology.Text = "EAN 8" Then
                Barcode.SymbologyID = Barcode.Symbologies.Ean8
            ElseIf cboSymbology.Text = "MICRO_PDF417" Then
                Barcode.SymbologyID = Barcode.Symbologies.MicroPDF417
                If Val(txtPDFColumns.Text) > 4 Then
                    txtPDFColumns.Text = 4
                    Barcode.PDFColumns = 4
                End If
            ElseIf cboSymbology.Text = "PDF417" Then
                Barcode.SymbologyID = Barcode.Symbologies.PDF417


            ElseIf cboSymbology.Text = "DataBar" Then
                Barcode.SymbologyID = Barcode.Symbologies.Databar
                If (Barcode.DataBarSuggestedHeight = True) Then
                    If (mnuSetToMetric.Checked = True) Then
                        txtBarHeight.Text = Barcode.BarHeightCM
                    End If
                End If

            ElseIf cboSymbology.Text = "DataBar Truncated" Then
                Barcode.SymbologyID = Barcode.Symbologies.DatabarTruncated
                If (Barcode.DataBarSuggestedHeight = True) Then
                    If (mnuSetToMetric.Checked = True) Then
                        txtBarHeight.Text = Barcode.BarHeightCM
                    End If
                End If

            ElseIf cboSymbology.Text = "DataBar Stacked" Then
                Barcode.SymbologyID = Barcode.Symbologies.DatabarStacked
                If (Barcode.DataBarSuggestedHeight = True) Then
                    If (mnuSetToMetric.Checked = True) Then
                        txtBarHeight.Text = Barcode.BarHeightCM
                    End If
                End If

            ElseIf cboSymbology.Text = "DataBar Stacked Omnidirectional" Then
                Barcode.SymbologyID = Barcode.Symbologies.DatabarStackedOmnidirectional
                If (Barcode.DataBarSuggestedHeight = True) Then
                    If (mnuSetToMetric.Checked = True) Then
                        txtBarHeight.Text = Barcode.BarHeightCM
                    End If
                End If

            ElseIf cboSymbology.Text = "DataBar Limited" Then
                Barcode.SymbologyID = Barcode.Symbologies.DatabarLimited
                If (Barcode.DataBarSuggestedHeight = True) Then
                    If (mnuSetToMetric.Checked = True) Then
                        txtBarHeight.Text = Barcode.BarHeightCM
                    End If
                End If

            ElseIf cboSymbology.Text = "DataBar Expanded" Then
                Barcode.SymbologyID = Barcode.Symbologies.DatabarExpanded
                '3/24/2009, TB, changed the segemts to a combo box.
                'txtSegments.Visible = True
                cboSegments.Visible = True
                lblSegments.Visible = True
                lblSegmentsDesc.Visible = True
                If (Barcode.DataBarSuggestedHeight = True) Then
                    If (mnuSetToMetric.Checked = True) Then
                        txtBarHeight.Text = Barcode.BarHeightCM
                    End If
                End If

            ElseIf cboSymbology.Text = "UPCa" Then
                Barcode.SymbologyID = Barcode.Symbologies.UPCa
            ElseIf cboSymbology.Text = "UPCe" Then
                Barcode.SymbologyID = Barcode.Symbologies.UPCe
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub tabPDFProps_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tabPDFProps.Click
        If cboSymbology.Text = "PDF417" Then
            cboCompactionType.Items.Clear()
            cboCompactionType.Items.Add("Binary")
            cboCompactionType.Items.Add("Text")
        Else
            cboCompactionType.Items.Clear()
            cboCompactionType.Items.Add("Binary")
            cboCompactionType.Items.Add("Text")
            cboCompactionType.Items.Add("Numeric")
        End If
    End Sub

    Private Sub TabControl1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TabControl1.SelectedIndexChanged
        If OnStartUp = False Then
            If cboSymbology.Text = "PDF417" Then
                cboCompactionType.Items.Clear()
                cboCompactionType.Items.Add("Binary")
                cboCompactionType.Items.Add("Text")
            Else
                cboCompactionType.Items.Clear()
                cboCompactionType.Items.Add("Binary")
                cboCompactionType.Items.Add("Text")
                cboCompactionType.Items.Add("Numeric")
            End If

            Dim sValue As String = Barcode.PDFMode.ToString()
            Dim cboIndex As Integer = cboCompactionType.FindString(sValue)
            If cboIndex <> -1 Then
                cboCompactionType.SelectedIndex = cboIndex
            Else
                sValue = "Text"
                cboIndex = cboCompactionType.FindString(sValue)
                cboCompactionType.SelectedIndex = cboIndex
            End If
        End If
    End Sub

    Private Sub txtCompositeData_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCompositeData.TextChanged
        If OnStartUp = False Then
            If txtCompositeData.Text <> "" Then
                Barcode.IsComposite = True
            Else
                Barcode.IsComposite = False
            End If
            Barcode.CompositeData = txtCompositeData.Text
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub chkIncludeAI_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkIncludeAI.CheckedChanged
        If OnStartUp = False Then
            If chkIncludeAI.Checked = True Then
                Barcode.IncludeAIinHRText = True
            Else
                Barcode.IncludeAIinHRText = False
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub chkIncludeLinkageFlag_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkIncludeLinkageFlag.CheckedChanged
        If OnStartUp = False Then
            If chkIncludeLinkageFlag.Checked = True Then
                Barcode.IncludeLinkageFlaginHRText = True
            Else
                Barcode.IncludeLinkageFlaginHRText = False
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub txtUPCSeparation_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtUPCSeparation.TextChanged
        If OnStartUp = False Then
            If Val(txtUPCSeparation.Text) > 0 And Val(txtUPCSeparation.Text) < 10 Then
                If mnuSetToMetric.Checked = True Then
                    Barcode.SuppSeparationCM = Val(txtUPCSeparation.Text)
                Else
                    Barcode.SuppSeparationCM = ConvertInchestoCM(txtUPCSeparation.Text)
                End If
            ElseIf Val(txtUPCSeparation.Text) = 0 Then
                Barcode.SuppSeparationCM = "0"
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub cboCompactionType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboCompactionType.SelectedIndexChanged
        If OnStartUp = False Then
            If cboCompactionType.Text = "Numeric" Then
                Barcode.PDFMode = MicroPDF417.MicroPDF417_CompactionModes.Numeric
                lblPDFMaxLength.Text = PDF417_NUMERIC_EXPLANATION
            ElseIf cboCompactionType.Text = "Text" Then
                Barcode.PDFMode = MicroPDF417.MicroPDF417_CompactionModes.Text
                lblPDFMaxLength.Text = PDF417_TEXT_EXPLANATION
            ElseIf cboCompactionType.Text = "Binary" Then
                Barcode.PDFMode = MicroPDF417.MicroPDF417_CompactionModes.Binary
                lblPDFMaxLength.Text = PDF417_BINARY_EXPLANATION
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub txtNumberPDFColumns_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtPDFColumns.TextChanged
        If OnStartUp = False Then
            Dim oldValue As String
            Try
                If txtPDFColumns.Text <> "" Then
                    Barcode.PDFColumns = txtPDFColumns.Text
                    PicBox.Image = getImage()
                End If
            Catch
            End Try
        End If
    End Sub

    Private Sub chkTruncate_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkTruncate.CheckedChanged
        If OnStartUp = False Then
            Barcode.TruncatePDF417 = chkTruncate.Checked
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub cboECLevel_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboECLevel.SelectedIndexChanged
        If OnStartUp = False Then
            If cboECLevel.Text = "Zero" Then
                Barcode.PDFErrorCorrectionLevel = Barcode.PDFErrorCorrectionLevel.Zero
            ElseIf cboECLevel.Text = "One" Then
                Barcode.PDFErrorCorrectionLevel = Barcode.PDFErrorCorrectionLevel.One
            ElseIf cboECLevel.Text = "Two" Then
                Barcode.PDFErrorCorrectionLevel = Barcode.PDFErrorCorrectionLevel.Two
            ElseIf cboECLevel.Text = "Three" Then
                Barcode.PDFErrorCorrectionLevel = Barcode.PDFErrorCorrectionLevel.Three
            ElseIf cboECLevel.Text = "Four" Then
                Barcode.PDFErrorCorrectionLevel = Barcode.PDFErrorCorrectionLevel.Four
            ElseIf cboECLevel.Text = "Five" Then
                Barcode.PDFErrorCorrectionLevel = Barcode.PDFErrorCorrectionLevel.Five
            ElseIf cboECLevel.Text = "Six" Then
                Barcode.PDFErrorCorrectionLevel = Barcode.PDFErrorCorrectionLevel.Six
            ElseIf cboECLevel.Text = "Seven" Then
                Barcode.PDFErrorCorrectionLevel = Barcode.PDFErrorCorrectionLevel.Seven
            ElseIf cboECLevel.Text = "Eight" Then
                Barcode.PDFErrorCorrectionLevel = Barcode.PDFErrorCorrectionLevel.Eight
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub txtXYRatio_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtXYRatio.TextChanged
        If OnStartUp = False Then
            If txtXYRatio.Text <> "" And Char.IsNumber(txtXYRatio.Text) = True Then
                Barcode.XtoYRatio = Val(txtXYRatio.Text)
                PicBox.Image = getImage()
            End If
        End If
    End Sub

    Private Sub DataBarSuggested_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDataBarSuggested.CheckedChanged
        If OnStartUp = False Then
            If chkDataBarSuggested.Checked = True Then
                Barcode.DataBarSuggestedHeight = True
            Else
                Barcode.DataBarSuggestedHeight = False
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub cboSegments_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSegments.SelectedIndexChanged
        If OnStartUp = False Then
            Select Case cboSegments.SelectedIndex
                Case 0
                    Barcode.ExpandedStackedSegments = 2
                Case 1
                    Barcode.ExpandedStackedSegments = 4
                Case 2
                    Barcode.ExpandedStackedSegments = 6
                Case 3
                    Barcode.ExpandedStackedSegments = 8
                Case 4
                    Barcode.ExpandedStackedSegments = 10
                Case 5
                    Barcode.ExpandedStackedSegments = 12
                Case 6
                    Barcode.ExpandedStackedSegments = 14
                Case 7
                    Barcode.ExpandedStackedSegments = 16
                Case 8
                    Barcode.ExpandedStackedSegments = 18
                Case 9
                    Barcode.ExpandedStackedSegments = 20
                Case 10
                    Barcode.ExpandedStackedSegments = 22
            End Select
            PicBox.Image = getImage()
        End If
    End Sub
End Class
